/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.ajax;

import javax.faces.component.UIComponent;

import org.ajax4jsf.framework.ajax.AjaxContext;
import org.ajax4jsf.framework.ajax.AjaxEvent;
import org.ajax4jsf.framework.ajax.AjaxListener;
import org.ajax4jsf.framework.ajax.AjaxRenderEvent;
import org.ajax4jsf.framework.ajax.AjaxRenderListener;

/**
 * @author shura
 *
 */
public class ForceRender implements AjaxListener, AjaxRenderListener {

	/* (non-Javadoc)
	 * @see org.ajax4jsf.framework.ajax.AjaxListener#processAjax(org.ajax4jsf.framework.ajax.AjaxEvent)
	 */
	public void processAjax(AjaxEvent event) {
		UIComponent component = event.getComponent();
		AjaxRenderEvent renderEvent = new AjaxRenderEvent(component);
		renderEvent.setPhaseId(event.getPhaseId());
		component.queueEvent(renderEvent);
	}

	/* (non-Javadoc)
	 * @see org.ajax4jsf.framework.ajax.AjaxRenderListener#processAjaxRender(org.ajax4jsf.framework.ajax.AjaxRenderEvent)
	 */
	public void processAjaxRender(AjaxRenderEvent event) {
		AjaxContext.getCurrentInstance().renderSubmittedAjaxRegion();
	}

}
