/**
 * 
 */
package org.ajax4jsf.ajax.repeat;

import java.io.IOException;

import javax.faces.context.FacesContext;

/**
 * Interface for classes, able to receive visitor processing calls from ExtendedDataModel
 * @author shura
 *
 */
public interface DataVisitor {
	
	/**
	 * This method called back ( as visitor ) from {@link ExtendedDataModel#walk(FacesContext, DataVisitor, Range)} for
	 * each row.
	 * @param context current JSF context.
	 * @param rowKey current row key of DataModel 
	 * @param argument Implementation-specific argument
	 * @throws IOException
	 */
	public void process(FacesContext context,Object rowKey, Object argument) throws IOException;

}
