/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.ajax.resource;

import javax.faces.component.UIOutput;

/**
 * @author shura
 *
 */
public abstract class UIMediaOutput extends UIOutput implements ResourceComponent {
	
    public static final String COMPONENT_TYPE = "org.ajax4jsf.MMedia";

	/**
	 * Get URI attribute for resource ( src for images, href for links etc ).
	 * @return
	 */
	public abstract String getUriAttribute();

	/**
	 * Set URI attribute for resource ( src for images, href for links etc ).
	 * @param newvalue
	 */
	public abstract void setUriAttribute(String newvalue);
	
	/**
	 * Get Element name for rendering ( imj , a , object, applet ).
	 * @return
	 */
	public abstract String getElement();

	/**
	 * Set Element name for rendering ( imj , a , object, applet ).
	 * @param newvalue
	 */
	public abstract void setElement(String newvalue);
	

}
