/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework;

import java.util.Iterator;

import javax.faces.lifecycle.Lifecycle;
import javax.faces.lifecycle.LifecycleFactory;

/**
 * @author shura (latest modification by $Author: alexsmirnov $)
 * @version $Revision: 1.5 $ $Date: 2006/11/17 21:46:47 $
 *
 */
public class DebugLifecycleFactory extends LifecycleFactory {
	
	private LifecycleFactory _defaultFactory;
	
	private DebugLifecycle _debugLifecycle ;
	
//	private Map _lifecycles = new HashMap();

	/**
	 * @return the debugLifecycle
	 */
	private DebugLifecycle getDebugLifecycle() {
		if (_debugLifecycle == null) {
			_debugLifecycle = new DebugLifecycle(_defaultFactory);			
		}

		return _debugLifecycle;
	}

	/**
	 * @param defaultFactory
	 */
	public DebugLifecycleFactory(LifecycleFactory defaultFactory) {
		super();
		this._defaultFactory = defaultFactory;
	}

	/* (non-Javadoc)
	 * @see javax.faces.lifecycle.LifecycleFactory#addLifecycle(java.lang.String, javax.faces.lifecycle.Lifecycle)
	 */
	public void addLifecycle(String arg0, Lifecycle arg1) {
		this._defaultFactory.addLifecycle(arg0, arg1);
	}

	/* (non-Javadoc)
	 * @see javax.faces.lifecycle.LifecycleFactory#getLifecycle(java.lang.String)
	 */
	public Lifecycle getLifecycle(String lifecycleId) {
		Lifecycle life;
		if(DebugLifecycle.DEBUG_LYFECYCLE_ID.equals(lifecycleId)) {
			life = getDebugLifecycle();
		} else {
			life = this._defaultFactory.getLifecycle(lifecycleId);
		}
		return life;
	}

	/* (non-Javadoc)
	 * @see javax.faces.lifecycle.LifecycleFactory#getLifecycleIds()
	 */
	public Iterator getLifecycleIds() {
		return this._defaultFactory.getLifecycleIds();
	}

}
