/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.ajax;

import java.io.IOException;
import java.util.Set;

import javax.faces.context.FacesContext;

/**
 * Marker interface for components, have ability to manipulate rendering in case of Ajax responses.
 * Such as ajax-enabled iterator, menus etc
 * @author shura
 *
 */
public interface AjaxChildrenEncoder {

    /**
     * Iterate over all childs of components. If component id contains in list ,
     * or, if list is empty, compotents is submitted form - render it.
     * TODO - Instead of calculate full path for every component, build current Path
     * for componet and send as parameter.
     * 
     * @param context -
     *            current context
     * @param component -
     *            curent faces component.
     * @param ids -
     *            list of Id to render.
     * @throws IOException
     */
    public void encodeAjaxChild(FacesContext context, 
            String path,Set ids,Set renderedAreas) throws IOException ;


}
