/**
 * Copyright 2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ajax4jsf.framework.ajax;

import java.io.IOException;

import javax.faces.context.FacesContext;


/**
 * Extend Ajax-enabled region to support event listeners on Ajax requests.
 * @author shura (latest modification by $Author: alexsmirnov $)
 * @version $Revision: 1.8 $ $Date: 2006/07/29 11:49:04 $
 * 
 */
public interface AjaxContainer extends AjaxContainerBase, AjaxSource
{

    /**
     * Is ajax container must re-render all output from page or only it's children ?
     * @return true if all ajax-enabled to re-render araes on page must be checked for output.
     */
    public abstract boolean isRenderRegionOnly();
    
    public abstract void setRenderRegionOnly(boolean reRenderPage);

	/**
	 * Encode AJAX response from this container ( call encode methods for selected components only )
	 * @param context
	 * @throws IOException 
	 */
	public void encodeAjax(FacesContext context) throws IOException ;


}