/**
 * Copyright 2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ajax4jsf.framework.ajax;

import javax.faces.event.FacesListener;

/**
 * Base interface for all listeners, capable for receive <code>AjaxEvent</code>
 * @author shura (latest modification by $Author: sergeysmirnov $)
 * @version $Revision: 1.1 $ $Date: 2006/04/28 02:04:55 $
 */
public interface AjaxListener extends FacesListener {

    public static final Class[] AJAX_LISTENER_ARGS = { AjaxEvent.class };

    /**
     * @param event - to process
     */
    void processAjax(AjaxEvent event);

}
