/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.ajax;

/**
 * Marker interface for all JSF components, encoded ( or not ) on rendering
 * Ajax request , depend on it self properties ( such as messages, help or like components )
 * @author shura (latest modification by $Author: sergeysmirnov $)
 * @version $Revision: 1.1 $ $Date: 2006/04/28 02:05:03 $
 *
 */
public interface AjaxOutput {
	/**
	 * getter for ajax-rendered flag property.
	 * @return
	 */
	public boolean isAjaxRendered();
	/**
	 * Setter for ajax rendered property.
	 * @param ajaxRendered
	 */
	public void setAjaxRendered(boolean ajaxRendered);
	
	/**
	 * getter for ajax-rendered flag property.
	 * @return
	 */
	public boolean isKeepTransient();
	/**
	 * Setter for ajax rendered property.
	 * @param ajaxRendered
	 */
	public void setKeepTransient(boolean ajaxRendered);
	
	
}
