/**
 * Copyright 2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ajax4jsf.framework.ajax;


import javax.faces.context.FacesContext;
import javax.faces.event.AbortProcessingException;
import javax.faces.event.ActionEvent;
import javax.faces.event.ActionListener;
import javax.faces.event.ValueChangeEvent;
import javax.faces.event.ValueChangeListener;

import org.ajax4jsf.framework.renderer.AjaxRendererUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;



/**
 * @author shura
 * 
 * Listener for append refreshed region to ajax viev.
 */
public class AjaxRegionListener implements ActionListener, ValueChangeListener
         {

    public static Log log = LogFactory.getLog(AjaxRegionListener.class);

    /*
     * (non-Javadoc)
     * 
     * @see javax.faces.event.ActionListener#processAction(javax.faces.event.ActionEvent)
     */
    public void processAction(ActionEvent actionEvent)
            throws AbortProcessingException {
        AjaxRendererUtils.addRegionsFromComponent(actionEvent.getComponent(), FacesContext.getCurrentInstance());
    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.faces.event.ValueChangeListener#processValueChange(javax.faces.event.ValueChangeEvent)
     */
    public void processValueChange(ValueChangeEvent event)
            throws AbortProcessingException {
        AjaxRendererUtils.addRegionsFromComponent(event.getComponent(), FacesContext.getCurrentInstance());

    }

}
