/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.ajax;

import javax.faces.component.UIComponent;
import javax.faces.event.FacesEvent;
import javax.faces.event.FacesListener;

/**
 * @author asmirnov@exadel.com (latest modification by $Author: alexsmirnov $)
 * @version $Revision: 1.2 $ $Date: 2006/08/25 12:30:40 $
 *
 */
public class AjaxRenderEvent extends FacesEvent {

	/**
	 * @param component
	 */
	public AjaxRenderEvent(UIComponent component) {
		super(component);
	}

	public boolean isAppropriateListener(FacesListener listener) {
		// TODO Auto-generated method stub
		return listener instanceof AjaxRenderListener;
	}

	public void processListener(FacesListener listener) {
		if (listener instanceof AjaxRenderListener) {
			AjaxRenderListener renderListener = (AjaxRenderListener) listener;
			renderListener.processAjaxRender(this);
		}
		
	}

	/* (non-Javadoc)
	 * @see javax.faces.event.FacesEvent#getPhaseId()
	 */
//	public PhaseId getPhaseId() {
//		// TODO Auto-generated method stub
//		return PhaseId.INVOKE_APPLICATION;
//	}
	
	

}
