/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.ajax;

import javax.faces.component.UIComponent;

/**
 * Version of {@link org.ajax4jsf.framework.ajax.AjaxComponent} for append
 * Ajax functions for non-ajax components
 * @author asmirnov@exadel.com (latest modification by $Author: alexsmirnov $)
 * @version $Revision: 1.3 $ $Date: 2006/07/13 16:54:49 $
 *
 */
public interface AjaxSupport extends AjaxComponent {

    /**
     * @return JavaScript eventString. Rebuild on every call, since
     * can be in loop ( as in dataTable ) with different parameters.
     */
    public String getEventString();
    /**
     * setter method for property
     * @param new value of Name of event property of parent component for build JavaScript AJAX.Submit call to set
     */
    public abstract void setEvent(String event);

    /**
     * @return value or result of valueBinding of Name of event property of parent component for build JavaScript AJAX.Submit call
     */
    public abstract String getEvent();


    /**
	 * Getter for property If true, disable default action for target event ( encode 'return false' to JavaScript ), implementation will be generated by
	 * componnents-generator
	 * @return property value
	 */
	public abstract boolean isDisableDefault();

	/**
	 * Setter for property If true, disable default action for target event ( encode 'return false' to JavaScript ), implementation will be generated by
	 * componnents-generator
	 * @param newvalue - new property value
	 */
	public abstract void setDisableDefault(boolean newvalue);
	
	/**
	 * Set property for JavaScrept event generated by this component.
	 * @param parent
	 */
	public void setParentProperties(UIComponent parent);
}
