/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.ajax;

import javax.faces.component.UIComponent;
import javax.faces.event.ActionEvent;
import javax.faces.event.PhaseId;

/**
 * Action event - always assigned to {@link javax.faces.event.PhaseId#PROCESS_VALIDATIONS} phase
 * for bypass change phase in components , setPhaseId method do nothing.
 * @author shura (latest modification by $Author: sergeysmirnov $)
 * @version $Revision: 1.1 $ $Date: 2006/04/28 02:05:01 $
 *
 */
public class AjaxValidationActionEvent extends ActionEvent {

	/**
	 * 
	 */
	private static final long serialVersionUID = 941784856915815112L;

	/**
	 * @param component
	 */
	public AjaxValidationActionEvent(UIComponent component) {
		super(component);
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see javax.faces.event.FacesEvent#getPhaseId()
	 */
	public PhaseId getPhaseId() {
		// TODO Auto-generated method stub
		return PhaseId.PROCESS_VALIDATIONS;
	}

	
}
