/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.ajax;

import java.io.IOException;

import javax.faces.context.FacesContext;


/**
 * Version for {@link AjaxViewRoot} for sun 1.1 RI - since only this
 * implementation need to reset unique ID counter at every request.
 * @author asmirnov@exadel.com (latest modification by $Author: alexsmirnov $)
 * @version $Revision: 1.3 $ $Date: 2006/08/25 12:30:40 $
 *
 */
public class AjaxViewRootRIOneOne extends AjaxViewRoot {

	/* (non-Javadoc)
	 * @see org.ajax4jsf.framework.ajax.AjaxViewRoot#encodeBegin(javax.faces.context.FacesContext)
	 */
	public void encodeBegin(FacesContext arg0) throws IOException {
		AjaxContext.getCurrentInstance().resetUniqueIdCounter();
		super.encodeBegin(arg0);
	}

	/* (non-Javadoc)
	 * @see javax.faces.component.UIViewRoot#createUniqueId()
	 * store id counter in request scope variables to avoid concurrent request processing
	 */
	public String createUniqueId() {
		return UNIQUE_ID_PREFIX+AjaxContext.getCurrentInstance().getUniqueIdCounter();
	}

}
