/**
 * Copyright 2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ajax4jsf.framework.ajax.xmlfilter;

import org.ajax4jsf.framework.ajax.xmlfilter.nekko.NekkoXMLFilter;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


/**
 * This class implements a simple Servlet filter that convert basic html
 * output of JSF to valid XML or JavaScript, for parsing different versions
 * of XmlHttpRequest's on client side.
  */
public class NekkoFilter extends BaseFilter implements javax.servlet.Filter {
	static final Log log = LogFactory.getLog(NekkoFilter.class);
	
	/**
	 * 
	 */
	public NekkoFilter() {
		super();
		// default - not force
//		setForcexml(false);
		xmlFilter = new NekkoXMLFilter();
		xmlFilter.setFilter(this);
	}

} 


