/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.ajax.xmlfilter;

import java.io.IOException;

import javax.servlet.http.HttpServletResponse;
import javax.xml.transform.Source;
import javax.xml.transform.sax.SAXSource;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.xml.sax.ContentHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;


/**
 * Parse saved JSF output by NekkoHtml parser
 * @author shura (latest modification by $Author: alexsmirnov $)
 * @version $Revision: 1.2 $ $Date: 2006/06/13 18:36:33 $
 *
 */
public class NekkoHtmlServletResponseWrapper extends FilterServletResponseWrapper {

	private static  final Log log = LogFactory.getLog(NekkoHtmlServletResponseWrapper.class);
	private XMLReader parser;
	/**
	 * @param response
	 */
	public NekkoHtmlServletResponseWrapper(HttpServletResponse response) {
		super(response);
		// TODO Auto-generated constructor stub
	}

	public void parse(ContentHandler contentHandler) throws IOException, SAXException, RuntimeException {
		parser.setContentHandler(contentHandler);
		parser.parse(getContentAsInputSource());
	}

	/**
	 * @param parser
	 */
	public void setParser(XMLReader parser) {
		// TODO Auto-generated method stub
		this.parser = parser;
	}

	/**
	 * @return Returns the parser.
	 */
	public XMLReader getParser() {
		return this.parser;
	}

	/* (non-Javadoc)
	 * @see org.ajax4jsf.framework.ajax.xmlfilter.FilterServletResponseWrapper#getContentAsSource()
	 */
	public Source getContentAsSource() {
	    try {
	        InputSource inputSource = getContentAsInputSource();	
	        // Parse the output only if text was generated
	            //inputSource.setSystemId();
	            parser.setProperty("http://cyberneko.org/html/properties/default-encoding",this.getCharacterEncoding());
	            return new SAXSource(parser,inputSource);
	    } catch (Exception e) {
	        throw new RuntimeException(e.getMessage(),e);
	    }
	}

}
