/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.ajax.xmlfilter;

import org.ajax4jsf.framework.ajax.xmlfilter.tidy.TidyXMLFilter;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


/**
 * Convert Html Output to XML using Jtidy.
 * @author shura (latest modification by $Author: alexsmirnov $)
 * @version $Revision: 1.10 $ $Date: 2006/07/05 08:53:36 $
 */
public class TidyFilter extends BaseFilter {
	static final Log log = LogFactory.getLog(TidyFilter.class);
	
	public TidyFilter() {
		// For Tidy, publicId can be pre-defined omit | auto | strict | loose | ignore | [fpi]
		xmlFilter = new TidyXMLFilter();
		xmlFilter.setFilter(this);
		xmlFilter.setPublicid("omit");		
	}

}
