/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.ajax.xmlfilter;

import javax.servlet.http.HttpServletResponse;

import org.ajax4jsf.framework.ajax.xmlfilter.tidy.TidyParser;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * @author asmirnov@exadel.com (latest modification by $Author: alexsmirnov $)
 * @version $Revision: 1.4 $ $Date: 2006/07/05 08:53:37 $
 *
 */
public class TidyServletResponseWrapper extends FilterServletResponseWrapper {

	private static  final Log log = LogFactory.getLog(TidyServletResponseWrapper.class);
	
	TidyParser parser;

	/**
	 * @param response
	 */
	public TidyServletResponseWrapper(HttpServletResponse response) {
		super(response);
		// TODO Auto-generated constructor stub
	}

	/**
	 * @return Returns the parser.
	 */
	public TidyParser getParser() {
		return this.parser;
	}

	/**
	 * @param parser The parser to set.
	 */
	public void setParser(TidyParser parser) {
		this.parser = parser;
	}

}
