/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package org.ajax4jsf.framework.renderer;

import java.io.Serializable;
import java.util.HashMap;

/**
 * 	storing tempates variables
 *  @author ayukhovich@exadel.com (latest modification by $Author: alexsmirnov $)
 *  @version $Revision: 1.3 $ $Date: 2006/09/10 20:03:44 $
 */
public class ComponentVariables implements Serializable {
	
	private transient HashMap variablesMap = new HashMap();
	
	/**
	 * setting variable 
	 * @param variableName
	 * @param variable
	 */
	public void setVariable(final String variableName, final Object variable ) {
		variablesMap.put(variableName, variable);	
	}
	
	/**
	 * 
	 * @param variableName
	 * @return
	 */
	public Object getVariable(final String variableName ) {
		return variablesMap.get(variableName);
	}
	
	
	/**
	 *
	 * @param variableName
	 * @param addValue
	 */
	public void addValueToVariable(final String variableName, final Object addValue) {
		Object variable = getVariable(variableName);
		if ( variable == null )
			return;
		
		if (variable instanceof Integer) {
			addToValue( variableName,(Integer) variable,  addValue);
		}
	}
	
	/**
	 * 
	 * @param variableName
	 * @param variable
	 * @param addValue
	 */
	protected void addToValue(final String variableName, Integer variable, final Object addValue ) {
		Integer retultValue;
		if ( addValue instanceof Integer )	{
			Integer intAddValue =(Integer)addValue; 
			retultValue = new Integer(variable.intValue() + intAddValue.intValue());
		} else {
			retultValue = variable;
		}
		
		setVariable(variableName, retultValue);
	}
	
}
