/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.renderer;

import java.util.LinkedHashSet;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;

import org.ajax4jsf.framework.resource.InternetResource;
import org.ajax4jsf.framework.resource.PrototypeScript;


/**
 * @author Maksim Kaszynski
 *
 */
public abstract class PrototypeBasedRendererBase extends RendererBase implements HeaderResourceProducer{

	protected static final String[] EMPTY_ARRAY = {};
	private InternetResource prototypeScript = getResource(PrototypeScript.class.getName());
	
	public LinkedHashSet getHeaderScripts(FacesContext context, UIComponent component) {
		LinkedHashSet scripts = new LinkedHashSet() ; // Collections.singleton(ajaxScript.getUri(context, null));
		scripts.add(prototypeScript.getUri(context, null));
		String[] additionalScripts = getAdditionalScripts();
		for (int i = 0; i < additionalScripts.length; i++) {
			String resource = additionalScripts[i];
			scripts.add(getResource(resource).getUri(context, null));
		}
		return scripts;
	}

	/* (non-Javadoc)
	 * @see org.ajax4jsf.framework.renderer.HeaderResourceProducer#getHeaderStyles(javax.faces.context.FacesContext)
	 */
	public LinkedHashSet getHeaderStyles(FacesContext context, UIComponent component) {
		// TODO Auto-generated method stub
		return null;
	}

	protected String[] getAdditionalScripts() {
		return EMPTY_ARRAY;
	}
	
}
