/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.renderer.compiler;

import java.io.IOException;

import org.xml.sax.SAXException;

/**
 * @author shura (latest modification by $Author: sergeysmirnov $)
 * @version $Revision: 1.1 $ $Date: 2006/04/28 02:04:21 $
 *
 */
public class ValueMethodCallElement extends MethodCallElement {

	/* (non-Javadoc)
	 * @see org.ajax4jsf.framework.renderer.compiler.MethodCallElement#encode(org.ajax4jsf.framework.renderer.compiler.TemplateContext)
	 */
	public void encode(TemplateContext context) throws IOException {
		// do nothing
	}

	/* (non-Javadoc)
	 * @see org.ajax4jsf.framework.renderer.compiler.MethodCallElement#setParent(org.ajax4jsf.framework.renderer.compiler.PreparedTemplate)
	 */
	public void setParent(PreparedTemplate parent) throws SAXException {
		// TODO Auto-generated method stub
		super.setParent(parent);
		if (parent instanceof ElementBase) {
			ElementBase base = (ElementBase) parent;
			base.valueGetter = new ElementBase.ValueGetter(){
				/* (non-Javadoc)
				 * @see org.ajax4jsf.framework.renderer.compiler.ElementBase.ValueGetter#getValue(org.ajax4jsf.framework.renderer.compiler.TemplateContext)
				 */
				Object getValue(TemplateContext context) {
					// TODO Auto-generated method stub
					return ValueMethodCallElement.this.getValue(context);
				}
			};
		}
	}
	/* (non-Javadoc)
	 * @see org.ajax4jsf.framework.renderer.compiler.PreparedTemplate#getTag()
	 */
	public String getTag() {
		return HtmlCompiler.NS_PREFIX+HtmlCompiler.VALUE_CALL_TAG;
	}

}
