/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.resource;

import java.awt.image.BufferedImage;
import java.awt.image.RenderedImage;
import java.io.DataOutputStream;
import java.io.IOException;

import org.ajax4jsf.framework.util.image.GIFEncoder;

/**
 * @author asmirnov@exadel.com (latest modification by $Author: alexsmirnov $)
 * @version $Revision: 1.2 $ $Date: 2006/11/15 14:58:28 $
 * 
 */
public class GifRenderer extends ImageRenderer {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.ajax4jsf.framework.resource.ResourceRenderer#getContentType()
	 */
	public String getContentType() {
		// TODO Auto-generated method stub
		return "image/gif";
	}

	public void sendImage(ResourceContext context, RenderedImage image)
			throws IOException {
		// ImageIO.write(image,"gif",context.getOutputStream());
		GIFEncoder encoder = new GIFEncoder();
		DataOutputStream out = new DataOutputStream(context.getOutputStream());
		try {
			encoder.encode((BufferedImage) image, out);
			out.flush();
			out.close();

		} catch (Exception e) {
			// IE can unexpected close connection
		}
	}

	public int getImageType() {
		// TODO Auto-generated method stub
		return BufferedImage.TYPE_INT_ARGB;
	}

}
