/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package org.ajax4jsf.framework.resource;

import java.io.InputStream;


/**
 * Class stoped all resources in application classpath.
 * TODO - set last midified & expired values.
 * @author shura (latest modification by $Author: alexsmirnov $)
 * @version $Revision: 1.4 $ $Date: 2006/09/20 15:09:37 $
 *
 */
public class JarResource extends InternetResourceBase {
	
	/**
	 * Default place for all static resources in Jar.
	 * to avoid access to any class in application, only allowed subpackages for
	 * META-INF/resources
	 */
	public static final String RESOURCES_ROOT="META-INF/resources";

	private String path;
	
	public JarResource(){
		
	}

	public JarResource(String path) {
		this.path = path;
	}

	/* (non-Javadoc)
	 * @see org.ajax4jsf.framework.resource.InternetResourceBase#getResourceAsStream(javax.faces.context.FacesContext, java.lang.Object)
	 */
	public InputStream getResourceAsStream(ResourceContext context) {
		ClassLoader loader = Thread.currentThread().getContextClassLoader();
		return loader.getResourceAsStream(path);
	}

	public String getPath() {
		return path;
	}

	public void setPath(String path) {
		this.path = path;
	}


	
}
