/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.resource.cached;

import java.util.Arrays;

/**
 * @author shura
 *
 */
public class ResourceBytesDataBean extends ResourceBean {
	
	private byte[] data;
	
	ResourceBytesDataBean(String key, byte[] data){
		super(key);
		this.data = data;
	}
	
	public Object getData() {
		return data;
	}
	/* (non-Javadoc)
	 * @see com.exadel.vcp.resource.ResourceBean#equals(java.lang.Object)
	 */
	public boolean equals(Object obj) {
		if (null != obj && obj instanceof ResourceBytesDataBean) {
			ResourceBytesDataBean bean = (ResourceBytesDataBean) obj;
			byte[] beanData = (byte[]) bean.getData();
			return getKey().equals(bean.getKey()) && Arrays.equals(data, beanData);
		};
		return false;
	}

	/* (non-Javadoc)
	 * @see com.exadel.vcp.resource.ResourceBean#hashCode()
	 */
	public int hashCode() {
		int hash = super.hashCode();
		for (int i = 0; i < data.length; i++) {
			hash = hash*32+data[i];
		}
		return hash;
	}

}
