/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.resource.cached;


/**
 * @author shura
 *
 */
public class ResourceDataBean extends ResourceBean{
	
	private Object data;
	
	public ResourceDataBean(String key, Object data){
		super(key);
		this.data = data;
	}

	/* (non-Javadoc)
	 * @see com.exadel.vcp.resource.ResourceBean#equals(java.lang.Object)
	 */
	public boolean equals(Object obj) {
		if (null != obj && obj instanceof ResourceBean) {
			ResourceBean bean = (ResourceBean) obj;
			return getKey().equals(bean.getKey()) && data.equals(bean.getData());
		};
		return false;
	}

	/* (non-Javadoc)
	 * @see com.exadel.vcp.resource.ResourceBean#getData()
	 */
	public Object getData() {
		return data;
	}

	/* (non-Javadoc)
	 * @see com.exadel.vcp.resource.ResourceBean#hashCode()
	 */
	public int hashCode() {
		// TODO Auto-generated method stub
		return super.hashCode()*32+data.hashCode();
	}

}
