/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.skin;

import javax.faces.context.FacesContext;
import javax.faces.el.EvaluationException;
import javax.faces.el.VariableResolver;

/**
 * Resolve current skin as EL Variable. e.g. #{chameleonSkin['color'] } #{chameleonSkin.color}
 * must be evaluated as Skin.getProperty(context,"color");
 * @author asmirnov@exadel.com (latest modification by $Author: alexsmirnov $)
 * @version $Revision: 1.2 $ $Date: 2006/05/10 20:05:51 $
 *
 */
public class SkinVariableResolver extends VariableResolver {


	public static final String SKIN_VARIABLE_NAME = "vcpSkin";

	public static final String CHAMELEON_VARIABLE_NAME = "vcp";

	private VariableResolver parent = null;

	public SkinVariableResolver(VariableResolver parent){
		this.parent = parent;
	}
	/* (non-Javadoc)
	 * @see javax.faces.el.VariableResolver#resolveVariable(javax.faces.context.FacesContext, java.lang.String)
	 */
	public Object resolveVariable(FacesContext context, String name)
			throws EvaluationException {
		
		// TODO: Why do we need this?
		if(SKIN_VARIABLE_NAME.equals(name)){
			return SkinFactory.getInstance().getSkin(context);
		} else if(CHAMELEON_VARIABLE_NAME.equals(name)){
			return new VersionBean();
		}
		if (parent!=null) {
			Object ret = null;
			ret = parent.resolveVariable(context,name);
			return ret;
		} else {
			return null;
		}
	}

}
