/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.util.config;

import java.util.HashSet;
import java.util.Set;

/**
 * @author asmirnov@exadel.com (latest modification by $Author: alexsmirnov $)
 * @version $Revision: 1.3 $ $Date: 2006/11/28 17:10:14 $
 *
 */
public class FilterBean {
	private String _filterName;
	private String _filterClass;
	private String _displayName;
	private String _description;
	private Set _filterMappings = new HashSet();
	private Set _servlets = new HashSet();

	/**
	 * @return Returns the description.
	 */
	public String getDescription() {
		return _description;
	}
	/**
	 * @param description The description to set.
	 */
	public void setDescription(String description) {
		_description = description;
	}
	/**
	 * @return Returns the displayName.
	 */
	public String getDisplayName() {
		return _displayName;
	}
	/**
	 * @param displayName The displayName to set.
	 */
	public void setDisplayName(String displayName) {
		_displayName = displayName;
	}
	/**
	 * @return Returns the servletClass.
	 */
	public String getFilterClass() {
		return _filterClass;
	}
	/**
	 * @param servletClass The servletClass to set.
	 */
	public void setFilterClass(String servletClass) {
		_filterClass = servletClass;
	}
	/**
	 * @return Returns the servletName.
	 */
	public String getFilterName() {
		return _filterName;
	}
	/**
	 * @param servletName The servletName to set.
	 */
	public void setFilterName(String servletName) {
		_filterName = servletName.trim();
	}
	/* (non-Javadoc)
	 * @see java.util.Map#keySet()
	 */
	public Set getMappings() {
		return _filterMappings;
	}
	/* (non-Javadoc)
	 * @see java.util.Map#put(java.lang.Object, java.lang.Object)
	 */
	void addMapping(String mapping) {
		_filterMappings.add(mapping);
	}
	
	public void addServlet(String servlet) {
		_servlets.add(servlet.trim());
		
	}
	public Set getServlets() {
		return _servlets;
	}

}
