/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.util.config;

import java.util.HashSet;
import java.util.Set;

/**
 * @author asmirnov@exadel.com (latest modification by $Author: alexsmirnov $)
 * @version $Revision: 1.2 $ $Date: 2006/11/28 17:10:15 $
 *
 */
public class ServletBean {
	private String _servletName;
	private String _servletClass;
	private String _displayName;
	private String _description;
	private Set _servletMappings = new HashSet();
	/**
	 * @return Returns the description.
	 */
	public String getDescription() {
		return _description;
	}
	/**
	 * @param description The description to set.
	 */
	public void setDescription(String description) {
		_description = description;
	}
	/**
	 * @return Returns the displayName.
	 */
	public String getDisplayName() {
		return _displayName;
	}
	/**
	 * @param displayName The displayName to set.
	 */
	public void setDisplayName(String displayName) {
		_displayName = displayName;
	}
	/**
	 * @return Returns the servletClass.
	 */
	public String getServletClass() {
		return _servletClass;
	}
	/**
	 * @param servletClass The servletClass to set.
	 */
	public void setServletClass(String servletClass) {
		_servletClass = servletClass;
	}
	/**
	 * @return Returns the servletName.
	 */
	public String getServletName() {
		return _servletName;
	}
	/**
	 * @param servletName The servletName to set.
	 */
	public void setServletName(String servletName) {
		_servletName = servletName.trim();
	}
	/* (non-Javadoc)
	 * @see java.util.Map#keySet()
	 */
	public Set getMappings() {
		return _servletMappings;
	}
	/* (non-Javadoc)
	 * @see java.util.Map#put(java.lang.Object, java.lang.Object)
	 */
	void addMapping(String mapping) {
		_servletMappings.add(mapping);
	}


}
