/**
 * Copyright 2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ajax4jsf.framework.util.javascript;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author shura (latest modification by $Author: sergeysmirnov $)
 * @version $Revision: 1.1 $ $Date: 2006/04/28 02:04:05 $
 *
 */
public class JSFunction extends ScriptStringBase implements ScriptString
{

    private String name;
    private List parameters = null;
    
    
    
    /**
     * @param name
     */
    public JSFunction(String name)
    {
        // TODO Auto-generated constructor stub
        this.name = name;
    }



    /**
     * @param name
     * @param parameters
     */
    public JSFunction(String name, List parameters)
    {
        // TODO Auto-generated constructor stub
        this.name = name;
        this.parameters = parameters;
    }

    /**
     * @param name
     * @param parameters
     */
    public JSFunction(String name, Object parameter)
    {
        // TODO Auto-generated constructor stub
        this.name = name;
        this.parameters = new ArrayList(1);
        this.parameters.add(parameter);
    }


    public JSFunction addParameter(Object parameter)
    {
        if(this.parameters == null){
            this.parameters = new ArrayList();
        }
        this.parameters.add(parameter);
        return this;
    }
    
    public void appendScript(StringBuffer functionString){
        functionString.append(name).append('(');
        boolean first = true;
        for (Iterator param = parameters.iterator(); param.hasNext();)
        {
            Object element =  param.next();
            if(!first){
                functionString.append(',');
            }
            if (null != element) {
				functionString.append(ScriptUtils.toScript(element));
			} else {
				functionString.append("null");
			}
            first = false;
        }
        functionString.append(")");
    }
}
