/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package org.ajax4jsf.framework.util.style;

/**
 * @author Maksim Kaszynski
 *
 */
public class CSSSelector {
	private StringBuffer selectorBuffer;
	public CSSSelector() {
		selectorBuffer = new StringBuffer();
	}
	public CSSSelector(String selector){
		this();
		selectorBuffer.append(selector);
	}
	
	public CSSSelector addSelector(String selector){
		if(selector != null){
			if(selectorBuffer.length() > 0){
				selectorBuffer.append(' ');
			}
			selectorBuffer.append(selector);
		}
		return this;
	}
	public String toString() {
		return selectorBuffer.toString();
	}
}
