/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package org.ajax4jsf.io.parser;

import java.io.IOException;

public class KeywordState extends StringState {
	

	/**
	 * @param toCompare
	 * @param reachedState
	 */
	public KeywordState(String toCompare, ParserState reachedState) {
		super(toCompare, reachedState);
		// TODO Auto-generated constructor stub
	}

	boolean isAcceptChar(char c, ParsingContext context) {
		boolean matched = false;
		int currentStatePosition = context.getCurrentStatePosition();
		if(currentStatePosition<string.length){
			matched = Character.toLowerCase(c)==string[currentStatePosition];
		}
		if(matched){
			context.incCurrentStatePosition();
			context.setLastMatched(this);
		}
		else {
			context.setCurrentStatePosition(0);
			context.setLastMatched(null);
		}
		return matched;
	}

    /* (non-Javadoc)
	 * @see org.ajax4jsf.io.parser.ParserState#send(char, org.ajax4jsf.io.parser.ParsingContext)
	 */
	void send(char c, ParsingContext context) throws IOException {
		
		context.putChar(c);
	}

	
}
