/**
 * Copyright 2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ajax4jsf.renderers.ajax;


import javax.faces.context.FacesContext;

import org.ajax4jsf.framework.ajax.AjaxActionComponent;
import org.ajax4jsf.framework.renderer.compiler.HtmlCompiler;
import org.ajax4jsf.framework.renderer.compiler.PreparedTemplate;


/**
 * @author shura
 * Ajax Version of commandLink.
 */
public class AjaxCommandLinkRenderer extends AjaxTemplatedCommandRendererBase {

    public static final String RENDERER_TYPE = "org.ajax4jsf.components.AjaxLinkRenderer";

    private  PreparedTemplate template = HtmlCompiler.compileResource(AjaxCommandLinkRenderer.class,"templates/link.xhtml");

	protected Class getComponentClass() {
		// TODO Auto-generated method stub
		return AjaxActionComponent.class;
	}

    /*
     * (non-Javadoc)
     * 
     * @see javax.faces.render.Renderer#getRendersChildren()
     */
    public boolean getRendersChildren() {
        return true;
    }

	/* (non-Javadoc)
	 * @see org.ajax4jsf.renderers.ajax.AjaxCommandRendererBase#getTemplate()
	 */
	protected PreparedTemplate getTemplate(FacesContext context) {
		// TODO Auto-generated method stub
		return template;
	}
    
    
}
