/**
 * 
 */
package org.ajax4jsf.renderers.ajax;

import java.io.IOException;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import org.ajax4jsf.ajax.UIAjaxLog;
import org.ajax4jsf.framework.renderer.AjaxComponentRendererBase;
import org.ajax4jsf.framework.renderer.RendererUtils.HTML;

/**
 * @author shura
 *
 */
public class AjaxLogRenderer extends AjaxComponentRendererBase {

	/* (non-Javadoc)
	 * @see org.ajax4jsf.framework.renderer.RendererBase#getComponentClass()
	 */
	protected Class getComponentClass() {
		
		return UIAjaxLog.class;
	}

	/* (non-Javadoc)
	 * @see org.ajax4jsf.framework.renderer.RendererBase#doEncodeEnd(javax.faces.context.ResponseWriter, javax.faces.context.FacesContext, javax.faces.component.UIComponent)
	 */
	protected void doEncodeEnd(ResponseWriter writer, FacesContext context, UIComponent component) throws IOException {
		UIAjaxLog uiLog = (UIAjaxLog) component;
		StringBuffer script = new StringBuffer();
		String level = uiLog.getLevel();
		if(null != level){
			script.append("LOG.LEVEL = LOG.").append(level).append(";\n");			
		}
		script.append("LOG._onkeyUp = document.onkeyup;\n");
		script.append("document.onkeyup = function(e) { if (window.event) e = window.event; if (String.fromCharCode(e.keyCode) == \'").append(uiLog.getHotkey());
		script.append("\' & e.shiftKey & e.ctrlKey) LOG.openWindow('','").append(uiLog.getName()).append("'");
		String width = uiLog.getWidth();
		if( null == width ){
			width="800";
		}
		String height = uiLog.getHeight();
		if( null == height){
			height="600";
		}
		script.append(",'width=").append(width).append(",height=").append(height).append(",toolbar=0,scrollbars=1,location=0,statusbar=0,menubar=0,resizable=1,left = 240,top = 212'");
		script.append("); else if(LOG._onkeyUp) LOG._onkeyUp(e); };\n");
		// Write prepared script
		writer.startElement(HTML.SCRIPT_ELEM, component);
		writer.writeAttribute("type", "text/javascript", null);
		writer.writeText(script.toString(), null);
		writer.endElement(HTML.SCRIPT_ELEM);

	}

	
}
