/**
 * Copyright 2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ajax4jsf.renderers.ajax;

import java.util.Map;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;

import org.ajax4jsf.framework.ajax.AjaxEvent;
import org.ajax4jsf.framework.renderer.AjaxComponentRendererBase;
import org.ajax4jsf.framework.renderer.compiler.PreparedTemplate;
import org.ajax4jsf.framework.util.message.Messages;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;



/**
 * Since <code>UIAjaxRegion</code> dont render itself ( only set apropriate event to parent component )
 * only <code>decode()</code> method implemented.
 * In case of Ajax Request caused by event for a given component
 * send action event.
 * @author shura (latest modification by $Author: alexsmirnov $)
 * @version $Revision: 1.7 $ $Date: 2006/11/24 17:10:10 $
 *
 */
public class AjaxSupportRenderer extends AjaxCommandRendererBase
{
    private static final Log log = LogFactory.getLog(AjaxSupportRenderer.class);

    /* (non-Javadoc)
     * @see javax.faces.render.Renderer#getRendersChildren()
     */
    public boolean getRendersChildren()
    {
        
        return false;
    }

	protected Class getComponentClass() {
		// TODO Auto-generated method stub
		return org.ajax4jsf.ajax.UIAjaxSupport.class;
	}

	protected PreparedTemplate getTemplate(FacesContext context) {
		return null;
	}

}
