/**
 * 
 */
package org.ajax4jsf.renderers.ajax;

import java.io.IOException;
import java.util.ListIterator;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;

import org.ajax4jsf.ajax.repeat.DataVisitor;
import org.ajax4jsf.ajax.repeat.UIRepeat;
import org.ajax4jsf.framework.renderer.RendererBase;

/**
 * @author shura
 * 
 */
public class RepeatRenderer extends RendererBase {

	public void encodeChildren(FacesContext context, UIComponent component)
			throws IOException {
		final UIRepeat repeater = (UIRepeat) component;
		repeater.captureOrigValue(context);
		try {
			DataVisitor visitor = new DataVisitor() {

				public void process(FacesContext context, Object rowKey, Object argument) throws IOException {
					repeater.setRowKey(rowKey);
					ListIterator childIterator = repeater.getChildren()
							.listIterator();
					while (childIterator.hasNext()) {
						UIComponent child = (UIComponent) childIterator.next();
						renderChild(context, child);
					}

				}

			};
			repeater.walk(context, visitor, null);

		} finally {
			repeater.restoreOrigValue(context);
			repeater.setRowKey(null);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.ajax4jsf.framework.renderer.RendererBase#getComponentClass()
	 */
	protected Class getComponentClass() {
		// TODO Auto-generated method stub
		return UIRepeat.class;
	}

	public boolean getRendersChildren() {
		return true;
	}

}
